import collections

__Xmp_Tag = collections.namedtuple('Xmp_Tag', 'n_decimal_places default_value is_vector is_ramped')

XMP_TAGS = {b'crs:Temperature': __Xmp_Tag(0, "6500", False, True),
            b'crs:Tint': __Xmp_Tag(0, "+7", True, True),
            b'crs:Saturation': __Xmp_Tag(0, "0", True, True),
            b'crs:Vibrance': __Xmp_Tag(0, "0", True, True),
            b'crs:Sharpness': __Xmp_Tag(0, "25", False, True),
            # b'crs:VignetteAmount': __Xmp_Tag(0, "0", True, False),
            # b'crs:VignetteMidpoint': __Xmp_Tag(0, "50", False, False),
            b'crs:ShadowTint': __Xmp_Tag(0, "0", True, True),
            b'crs:RedHue': __Xmp_Tag(0, "0", True, True),
            b'crs:RedSaturation': __Xmp_Tag(0, "0", True, True),
            b'crs:GreenHue': __Xmp_Tag(0, "0", True, True),
            b'crs:GreenSaturation': __Xmp_Tag(0, "0", True, True),
            b'crs:BlueHue': __Xmp_Tag(0, "0", True, True),
            b'crs:BlueSaturation': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentRed': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentOrange': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentYellow': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentGreen': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentAqua': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentBlue': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentPurple': __Xmp_Tag(0, "0", True, True),
            b'crs:HueAdjustmentMagenta': __Xmp_Tag(0, "0", True, True),
            b'crs:SaturationAdjustmentRed': __Xmp_Tag(0, "0", True, True),
            b'crs:SaturationAdjustmentOrange': __Xmp_Tag(0, "0", True, True),
            b'crs:SaturationAdjustmentYellow': __Xmp_Tag(0, "0", True, True),
            b'crs:SaturationAdjustmentGreen': __Xmp_Tag(0, "0", True, True),
            b'crs:SaturationAdjustmentAqua': __Xmp_Tag(0, "0", True, True),
            b'crs:SaturationAdjustmentBlue': __Xmp_Tag(0, "0", True, True),
            b'crs:SaturationAdjustmentPurple': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentRed': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentOrange': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentYellow': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentGreen': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentAqua': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentBlue': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentPurple': __Xmp_Tag(0, "0", True, True),
            b'crs:LuminanceAdjustmentMagenta': __Xmp_Tag(0, "0", True, True),
            # b'crs:SplitToningShadowHue': __Xmp_Tag(0, "0", False, False),
            # b'crs:SplitToningShadowSaturation': __Xmp_Tag(0, "0", False, False),
            # b'crs:SplitToningHighlightHue': __Xmp_Tag(0, "0", False, False),
            # b'crs:SplitToningHighlightSaturation': __Xmp_Tag(0, "0", False, False),
            # b'crs:SplitToningBalance': __Xmp_Tag(0, "0", True, False),
            b'crs:ParametricShadows': __Xmp_Tag(0, "0", True, True),
            b'crs:ParametricDarks': __Xmp_Tag(0, "0", True, True),
            b'crs:ParametricLights': __Xmp_Tag(0, "0", True, True),
            b'crs:ParametricHighlights': __Xmp_Tag(0, "0", True, True),
            b'crs:ParametricShadowSplit': __Xmp_Tag(0, "25", False, True),
            b'crs:ParametricMidtoneSplit': __Xmp_Tag(0, "50", False, True),
            b'crs:ParametricHighlightSplit': __Xmp_Tag(0, "75", False, True),
            b'crs:SharpenRadius': __Xmp_Tag(1, "+1.0", True, True),
            b'crs:SharpenDetail': __Xmp_Tag(0, "25", False, True),
            b'crs:SharpenEdgeMasking': __Xmp_Tag(0, "0", False, True),
            # b'crs:PostCropVignetteAmount': __Xmp_Tag(0, "0", True, False),
            # b'crs:PostCropVignetteMidpoint': __Xmp_Tag(0, "50", False, False),
            # b'crs:PostCropVignetteRoundness': __Xmp_Tag(0, "0", True, False),
            # b'crs:PostCropVignetteFeather': __Xmp_Tag(0, "0", False, False),
            # b'crs:PostCropVignetteHighlightContrast': __Xmp_Tag(0, "0", False, False),
            b'crs:GrainAmount': __Xmp_Tag(0, "0", False, True),
            b'crs:GrainSize': __Xmp_Tag(0, "25", False, True),
            b'crs:GrainFrequency': __Xmp_Tag(0, "50", False, True),
            b'crs:LuminanceSmoothing': __Xmp_Tag(0, "0", False, True),
            b'crs:LuminanceNoiseReductionDetail': __Xmp_Tag(0, "50", False, True),
            b'crs:LuminanceNoiseReductionContrast': __Xmp_Tag(0, "0", False, True),
            b'crs:ColorNoiseReduction': __Xmp_Tag(0, "25", False, True),
            b'crs:ColorNoiseReductionDetail': __Xmp_Tag(0, "50", False, True),
            b'crs:ColorNoiseReductionSmoothness': __Xmp_Tag(0, "50", False, True),
            #CRSLENSPROFILEENABLE ("", 0, "0", false),
            b'crs:LensManualDistortionAmount': __Xmp_Tag(0, "0", True, True),
            # b'crs:PerspectiveVertical': __Xmp_Tag(0, "0", True, False),
            # b'crs:PerspectiveHorizontal': __Xmp_Tag(0, "0", True, False),
            # b'crs:PerspectiveRotate': __Xmp_Tag(1, "0.0", True, False),
            # b'crs:PerspectiveScale': __Xmp_Tag(0, "100", False, False),
            # b'crs:PerspectiveAspect': __Xmp_Tag(0, "0", True, False),
            # CRSPERSPECTIVEUPRIGHT ("crs:PerspectiveUpright", 0, "0", false),
            # b'crs:PerspectiveX': __Xmp_Tag(1, "0.0", True, False),
            # b'crs:PerspectiveY': __Xmp_Tag(1, "0.0", True, False),
            # CRSAUSTOLATERALCA ("crs:AutoLateralCA", 0, "0", false),
            b'crs:Contrast2012': __Xmp_Tag(0, "0", True, True),
            b'crs:Highlights2012': __Xmp_Tag(0, "0", True, True),
            b'crs:Shadows2012': __Xmp_Tag(0, "0", True, True),
            b'crs:Whites2012': __Xmp_Tag(0, "0", True, True),
            b'crs:Blacks2012': __Xmp_Tag(0, "0", True, False),
            b'crs:Clarity2012': __Xmp_Tag(0, "0", True, True),
            b'crs:DefringePurpleAmount': __Xmp_Tag(0, "0", False, True),
            b'crs:DefringePurpleHueLo': __Xmp_Tag(0, "30", False, True),
            b'crs:DefringePurpleHueHi': __Xmp_Tag(0, "70", False, True),
            b'crs:DefringeGreenAmount': __Xmp_Tag(0, "0", False, True),
            b'crs:DefringeGreenHueLo': __Xmp_Tag(0, "40", False, True),
            b'crs:DefringeGreenHueHi': __Xmp_Tag(0, "60", False, True),
            b'crs:Dehaze': __Xmp_Tag(0, "0", True, True),
                # CRSTONEMAPSTRENGTH ("crs:ToneMapStrength", 0, "0", false),
            b'crs:CropLeft': __Xmp_Tag(6, "0", False, False),
            b'crs:CropBottom': __Xmp_Tag(6, "1", False, False),
            b'crs:CropRight': __Xmp_Tag(6, "1", False, False),
            b'crs:CropTop': __Xmp_Tag(6, "0", False, False),
            b'xmp:Rating': __Xmp_Tag(0, "0", False, False),
            b'crs:Exposure2012': __Xmp_Tag(2, "0", True, False),
            }


__Rendering_Tag = collections.namedtuple('Rendering_Tag', ['is_multi_valued', 'is_string', 'name', 'used_to_render'])

DEF_REND_TAG = __Rendering_Tag(False, False, '', False)

DNG_TAGS = {256: __Rendering_Tag(False, False, 'image_width', True),  # IMAGE_WIDTH
            257: __Rendering_Tag(False, False, 'image_length', True),  # IMAGE_LENGTH
            258: __Rendering_Tag(True, False, 'bits_per_sample', True),  # BYTES_PER_SAMPLE
            259: __Rendering_Tag(False, False, 'compression', True),  # COMPRESSION
            262: __Rendering_Tag(False, False, 'photometric_interpretation', True),  # PhotometricInterpretation (color space)
            273: __Rendering_Tag(True, False, 'strip_offsets', True),
            274: __Rendering_Tag(False, False, 'orientation', True),
            277: __Rendering_Tag(False, False, 'samples_per_pix', True),
            278: __Rendering_Tag(False, False, 'rows_per_strip', True),
            279: __Rendering_Tag(True, False, 'strip_byte_counts', True),
            284: __Rendering_Tag(False, False, 'planar_configuration', True),
            322: __Rendering_Tag(False, False, 'tile_width', True),
            323: __Rendering_Tag(False, False, 'tile_length', True),
            324: __Rendering_Tag(True, False, 'tile_offsets', True),
            325: __Rendering_Tag(True, False, 'tile_byte_counts', True),
            330: __Rendering_Tag(True, False, 'sub_ifds', False),
            339: __Rendering_Tag(True, False, 'sample_format', False),
            700: __Rendering_Tag(False, True, 'xmp', True),
            33421: __Rendering_Tag(True, False, 'cfa_repeat_pattern_dim', True),
            33422: __Rendering_Tag(True, False, 'cfa_pattern', True),
            # 34665: {'Name': 'exif_ifd', 'Used To Render': False},
            50710: __Rendering_Tag(False, False, 'cfa_plane_color', True),
            50711: __Rendering_Tag(False, False, 'cfa_layout', True),
            50712: __Rendering_Tag(True, False, 'linearization_table', True),
            50713: __Rendering_Tag(True, False, 'black_level_repeat_dim', True),
            50714: __Rendering_Tag(True, False, 'black_level', True),
            50715: __Rendering_Tag(True, False, 'black_level_delta_H', True),
            50716: __Rendering_Tag(True, False, 'black_level_delta_V', True),
            50717: __Rendering_Tag(True, False, 'white_level', True),
            50718: __Rendering_Tag(True, False, 'default_scale', True),
            50719: __Rendering_Tag(True, False, 'default_crop_origin', True),
            50720: __Rendering_Tag(True, False, 'default_crop_size', True),
            50829: __Rendering_Tag(True, False, 'active_area', True),
            50975: __Rendering_Tag(False, False, 'row_interleave_factor', True),
            }
